commit d3dd48e449dcd329126c4365c8f92335c8afa350
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Nov 6 10:55:05 2025 +0000

    fix radius expansion condition

diff --git a/src/src/miscmods/pam.c b/src/src/miscmods/pam.c
index 842282ba5..f39e09208 100644
--- a/src/src/miscmods/pam.c
+++ b/src/src/miscmods/pam.c
@@ -68,7 +68,7 @@ static int
 pam_converse (int num_msg, PAM_CONVERSE_ARG2_TYPE **msg,
   struct pam_response **resp, void *appdata_ptr)
 {
-int sep = 0;
+int sep = ':';
 struct pam_response *reply;
 
 /* It seems that PAM frees reply[] */
@@ -131,7 +131,7 @@ Returns:   OK if authentication succeeded
 static int
 auth_call_pam(const uschar * s, uschar ** errptr)
 {
-pam_handle_t *pamh = NULL;
+pam_handle_t * pamh = NULL;
 struct pam_conv pamc;
 int pam_error;
 int sep = ':';	/* Do not permit change-of-separator */
diff --git a/src/src/miscmods/radius.c b/src/src/miscmods/radius.c
index 3f8232756..fd75b3ae4 100644
--- a/src/src/miscmods/radius.c
+++ b/src/src/miscmods/radius.c
@@ -59,8 +59,8 @@ using its original API. At release 0.4.0 the API changed. */
 more data strings.
 
 Arguments:
-  s        a colon-separated list of strings
-  errptr   where to point an error message
+  radius_args	a colon-separated list of strings
+  errptr	where to point an error message
 
 Returns:   OK if authentication succeeded
            FAIL if authentication failed
@@ -68,12 +68,10 @@ Returns:   OK if authentication succeeded
 */
 
 static int
-auth_call_radius(const uschar *s, uschar **errptr)
+auth_call_radius(const uschar * radius_args, uschar ** errptr)
 {
-uschar *user;
-const uschar *radius_args = s;
-int result;
-int sep = ':';
+uschar * user, * pwd;
+int sep = ':', result;
 
 #ifdef RADIUS_LIB_RADLIB
   struct rad_handle *h;
@@ -89,9 +87,10 @@ int sep = ':';
 
 
 if (!(user = string_nextinlist(&radius_args, &sep, NULL, 0))) user = US"";
+pwd = string_nextinlist(&radius_args, &sep, NULL, 0);
 
 DEBUG(D_auth) debug_printf("Running RADIUS authentication for user %q "
-               "and %q\n", user, radius_args);
+               "and %q\n", user, pwd);
 
 *errptr = NULL;
 
@@ -112,7 +111,7 @@ else if (rc_read_dictionary(rc_conf_str("dictionary")) != 0)
 else if (!rc_avpair_add(&send, PW_USER_NAME, user, 0))
   *errptr = US"RADIUS: add user name failed";
 
-else if (!rc_avpair_add(&send, PW_USER_PASSWORD, CS radius_args, 0))
+else if (!rc_avpair_add(&send, PW_USER_PASSWORD, pwd, 0))
   *errptr = US"RADIUS: add password failed");
 
 else if (!rc_avpair_add(&send, PW_SERVICE_TYPE, &service, 0))

